# -- perl --

if ($ARGV[0] eq "--help")
{
   &ExtendedHelp;
}

while($ARGV[$i])
{
   if ( $ARGV[$i] =~ /\-/) 
   {
      &CheckOptions($ARGV[$i]);
   }
   $i=$i+1;
}

print `du -h @ARGV| <BINDIR>/du_filter.pl `;

sub CheckOptions {
    my($Option)=@_;
    foreach $char (split(//,$Option))
    {
         if ($char=~ /[^-c]/)
         { 
   	   	&Help;
	   	   exit;            
         }
    }
}

sub Help {
    print("\nUSAGE: route [-n]\n");
    print("\nUSAGE: route [-n] ID\n");
    print("\nUSAGE: route --help\n");
}

sub ExtendedHelp {
    print("route - Show i.p. routing table\n"); 
    print("Options\n");
    print("id   : Give me info on i.p.\n"); 
    print("       with that id\n");
    print("-n   : print i.p. in numeric format\n");
}
